%addpath('/media/usb/spmimp3D/modeldata')
addpath('~/spmimp3D/modeldata')

if(0)
    
P=GenerateGrid(4,4);
PR=rand(2,20);
for i=1:20
    PR(3,i)=0;
end

P=[P PR];

P0=Monster(1);
SP{1}=ModelPart(P0,-60,-40); %bottom: 4 points; no solution 
SP{2}=ModelPart(P0,-20,0); %108 two lines
SP{3}=ModelPart(P0,0,20);  %20 line
SP{8}=ModelPart(P0,20,40); %30 varioius points 
SP{5}=ModelPart(P0,40,60); %106 two lines. 
SP{6}=ModelPart(P0,60,70); %82 main circle
SP{7}=ModelPart(P0,70,90); %64 main circle 
SP{4}=ModelPart(P0,90,120); %top 20

%P=spinner4(1);
%P=Jis(1);
%P=SP{2};
%P=Misufa(1);
%P=ISO(1);
%P=Hvyhex(1);
%P=vstraining(1);
%P=demo06(1);
%P=Toolingblock(1);
%P=p6c(1);%a good example
P=Angle(1); %good example
%P=aries147(1);
%P=ModelPart(P,-400,-190); %top 20
%P=Frank(1);

%P=ViseGuide(1);
P=CombinePoints(P,2e-2);
%P=P+rand(size(P))*0.2;

nP=size(P,2);
fprintf('Point Number: %d.\n',nP);
D=DisCmp(P);

d1=min(D)
d2=max(D)

NrD=[];
md=1000.;
for i=1:nP
    [d,np]=NearestPDist(i,P,D);
    md=min(md,d);
    NrD(i,1)=d;
    NrD(i,2)=np;
end

%MEMIN=min([max(D)/100, 5*md])%this error is too small for Angle
MEMIN=10;%*min([max(D)/100])
%MEMIN=min(md)%this error is too small for Angle

t1 = cputime;
SS=DetectMIC(P,D,NrD,MEMIN,true);
t2=cputime;
time = t2-t1;
%DrawSymmetry(P,SS,5,5,1,size(SS,1),D);
fprintf('Valid MIC number: %d.\n', size(SS,1))
fprintf('Time cost for MIC detection: %d.\n', time)
%return; 
end


save('t','P','D', 'SS');
load 't' P D SS;

SS=EstimateSymmetryType(SS,P,D);%here, we use negative or positive to distinguish a set is complete or not. 
t2=cputime;
MS=CollectMS(SS);
fprintf('Symmetry type number: %d.\n', size(MS,1))
SMCC=[];
LC=[];
for i=1:size(MS,1)
    c=MS{i,1};
    LM=MS{i,2};%cycle list: 
    eM=MS{i,3}
    EM=MS{i,4};
    DM=MICDist(LM,EM,eM,D,P,c);
    sm0=size(SMCC,2);
    SMCC=MICCluster(LM,EM,eM,DM,SMCC);
    sm1=size(SMCC,2);
    LC(sm0+1:sm1)=c*ones(1,sm1-sm0);
end
time = cputime-t2;
fprintf('Valid Maximal incomplete symmetry set: %d.\n', size(SMCC,2));
fprintf('Time cost for incomplete symmetry detection: %d.\n', time);
DrawSMCC(SMCC,LC,P,2,2,1,size(SMCC,2))
 