function MS=CollectMS(SS)
%collect all the symmetry types for SS
%MS: set of MIC lists of the same types
MS=[];
ms=0;
for i=1:size(SS,1)
    S0=SS{i,2};
    eMin=SS{i,3};
    eMax=SS{i,4};
    T=SS{i,6};
    for j=1:size(T,2)
        c=T(j);
        if(c==-2) continue; end% don't consider 4 points but symmetry type not determined      
        c=abs(c);%%%complete and incomplete        
        isEx=false; 
        for k=1:size(MS,1)
            if(MS{k,1}==c) isEx=k; break; end
        end
        if(~isEx)
            LM=[]; eM=[]; EM=[];
            LM{1}=S0;
            eM(1)=eMin;
            EM(1)=eMax;
            ms=ms+1;
            MS{ms,1}=c;
            MS{ms,2}=LM;
            MS{ms,3}=eM;
            MS{ms,4}=EM;
        else
            LM=MS{isEx,2};
            eM=MS{isEx,3};
            EM=MS{isEx,4};
            n=size(EM,2)+1;
            LM{n}=S0;
            eM(n)=eMin;                
            EM(n)=eMax;            
            MS{isEx,2}=LM;
            MS{isEx,3}=eM;
            MS{isEx,4}=EM;
        end
    end
end