function [LM,EM,eM]=Generate2PMIC(P,D,NrD)
%LMS, EMS, EmS
LM=[]; % list of MIC's
EM=[]; % correspoding maximal tolerance array
eM=[]; % correspoding minimal tolerance array
s=0;
nP=size(P,2);
%generate 2-point MIC for mirror symmetry merging
%LM, EM, eM
for i=1:nP    
    for j=i+1:nP        
        %sort P(i),P(j) in proper order first
        t1=i; t2=j;               
        if(~isInc(P(:,t1),P(:,t2))) 
            t=t1; t1=t2; t2=t; 
        end
        s=s+1;
        LM{s}=[t1,t2];%MIC list
        d=D((t1-1)*nP+t2);
%        nd1=NrD(t1,1);
%        nd2=NrD(t2,1);
        eM(s)=0;
        EM(s)=min([d,nd1,nd2]);
    end
end
%NOTE: each MIC is represented by its point index in P

