function T=SymmetryTypes(S0,eMin,eMax,dr,Dr,c,D,P)
nP=size(P,2);
T=[];
ns0=size(S0,2);
if(c>0) 
    T(1)=c;
    return; end
n0=S0(1);
for i=2:ns0-1
    n1=S0(i);
    n2=S0(i+1);
    d1=D((n0-1)*nP+n1);
    d2=D((n0-1)*nP+n2);
    if(abs(d1-d2)<eMax-0.0001)%same group 
       c=2*i-1; T(1)=c; return; 
    end 
    if(d1-d2>eMax-0.0001)%discreasing group
       c=2*(i-1); T(1)=c; return; 
    end 
end

%T=[2*ns0-1:cM];
%T=[];

[x0, a, d, normd] = ls3dline(P(:,S0)'); 
if(normd<0.001) x0n=[];
else
    [x0n, an, rn, d, e] = CFit3D(S0, P);
%    NSS{s,7}=x0n;
%    ae=sqrt(dot(e,e))/ns0
%    eMin=eMin
%    if(ae>eMin) T(1)=-2; %not a valid symmetry 
%    end 
end

if(isempty(x0n)) T(1)=0; %translational symmetry
    return; end
   
[x0n, an, rn, d, e]=CFit3D(S0, P);
a=Angle(P(:,S0(1)),x0n,P(:,S0(ns0)))/(ns0-1);
ns=floor(2*pi/a);
T(1)=ns;
%T(2)=ns+1;

function a=Angle(P1,P2,P3)
d12=dot(P1-P2,P1-P2);
d23=dot(P3-P2,P3-P2);
d13=dot(P1-P3,P1-P3);
a=acos((d12+d23-d13)/(2*sqrt(d12*d23)));

